# HG changeset patch
# User Pantxo Diribarne <pantxo.diribarne@gmail.com>
# Date 1551995613 -3600
#      Thu Mar 07 22:53:33 2019 +0100
# Node ID 78563593339c7a98eccad12ba372cf73718fac8c
# Parent  156bd21bf6bdd059e21c516afc0d655ab94633c8
Use an uitoolbar and ui*tools to build the default figure toolbar (bug #55795)

* Figure.[cc,h] (mouse_mode_to_string, mouse_mode_from_string): Remove functions.
  (createFigureToolBarAndMenuBar, updateFigureToolBarAndMenuBar): Remove methods.
  (Figure::Figure): Instantiate the menubar here. Simplify size handling now
  that the toolbar is created in addCustomToolBar.
  (Figure::addCustomToolBar): Add optional argument to signal if the toolbar
  is the default one.
  (Figure::autoAxes, Figrue::toggleGrid, Figure::toggleAxes): Remove methods.

* GLCanvas.[cc,h] (GLCanvas::autoAxes, GLCanvas::toggleGrid,
  GLCanvas::toggleAxes): Ditto.

* Canvas.[cc,h] (Canvas::canvasAutoAxes, Canvas::canvasToggleGrid,
  Canvas::canvasToggleAxes): Ditto.
  (Canvas::setCursor): Use resourse_manager to retrieve icons.

* MouseModeActionGroup.[cc, h]: Remove unnecessary class file.

* __add_default_menu__.m: Add default toobar and associated buttons.

* libgui/graphics/qthandles.qrc: Remove file
* libgui/graphics/images: Remove directory.
* libgui/graphics/module.mk: Update to eliminate the Crystal icons resources.

* libgui/src/resources.qrc: Include new figure-* png icons
* libgui/src/module.mk: Include new figure-* png icons
* libgui/src/icons/icons_license: Document the origin of figure-* icons

diff --git a/libgui/graphics/Canvas.cc b/libgui/graphics/Canvas.cc
--- a/libgui/graphics/Canvas.cc
+++ b/libgui/graphics/Canvas.cc
@@ -43,6 +43,7 @@
 
 #include "oct-opengl.h"
 #include "octave-qt-link.h"
+#include "resource-manager.h"
 
 #include "builtin-defun-decls.h"
 
@@ -73,30 +74,45 @@
   Canvas::setCursor (MouseMode mode)
   {
     QWidget *w = qWidget ();
-
+    QCursor cursor = Qt::ArrowCursor;
     if (w)
       {
-        static QCursor origCursor = w->cursor ();
-
         switch (mode)
           {
+          case NoMode:
+          case SelectMode:
+            cursor = Qt::ArrowCursor;
+            break;
+
           case PanMode:
+            cursor = QCursor (octave::resource_manager::icon ("figure-pan")
+                              .pixmap (22, 22));
+            break;
+
           case RotateMode:
-            w->setCursor (Qt::OpenHandCursor);
+            cursor = QCursor (octave::resource_manager::icon ("figure-rotate")
+                              .pixmap (22, 22));
+            break;
+
+          case TextMode:
+            cursor = Qt::IBeamCursor;
             break;
 
           case ZoomInMode:
-            w->setCursor (QPixmap (":/images/zoom-in.png"));
+            cursor = QCursor (octave::resource_manager::icon ("figure-zoom-in")
+                              .pixmap (22, 22), 9, 9);
             break;
 
           case ZoomOutMode:
-            w->setCursor (QPixmap (":/images/zoom-out.png"));
+            cursor = QCursor (octave::resource_manager::icon ("figure-zoom-out")
+                              .pixmap (22, 22), 9, 9);
             break;
 
           default:
-            w->setCursor (origCursor);
+            cursor = Qt::ArrowCursor;
             break;
           }
+        w->setCursor (cursor);
       }
   }
 
@@ -191,73 +207,6 @@
     redraw ();
   }
 
-  void
-  Canvas::canvasToggleAxes (const graphics_handle& handle)
-  {
-    gh_manager::auto_lock lock;
-
-    graphics_object go = gh_manager::get_object (handle);
-
-    if (go.valid_object ())
-      {
-        figure::properties& fp = Utils::properties<figure> (go);
-
-        graphics_handle ah = fp.get_currentaxes ();
-
-        graphics_object ax = gh_manager::get_object (ah);
-
-        if (ax.valid_object ())
-          {
-            axes::properties& ap = Utils::properties<axes> (ax);
-
-            if (ap.handlevisibility_is ("on"))
-              {
-                ap.set_visible (! ap.is_visible ());
-
-                redraw (true);
-              }
-          }
-      }
-  }
-
-  void
-  Canvas::canvasToggleGrid (const graphics_handle& handle)
-  {
-    gh_manager::auto_lock lock;
-
-    graphics_object go = gh_manager::get_object (handle);
-
-    if (go.valid_object ())
-      {
-        figure::properties& fp = Utils::properties<figure> (go);
-
-        graphics_handle ah = fp.get_currentaxes ();
-
-        graphics_object ax = gh_manager::get_object (ah);
-
-        if (ax.valid_object ())
-          {
-            axes::properties& ap = Utils::properties<axes> (ax);
-
-            std::string tmp;
-
-            // If any grid is off, then turn them all on.  If they are all
-            // on, then turn them off.
-
-            std::string state = ((ap.get_xgrid () == "off"
-                                  || ap.get_ygrid () == "off"
-                                  || ap.get_zgrid () == "off")
-                                 ? "on" : "off");
-
-            ap.set_xgrid (state);
-            ap.set_ygrid (state);
-            ap.set_zgrid (state);
-
-            redraw (true);
-          }
-      }
-  }
-
   static void
   autoscale_axes (axes::properties& ap)
   {
@@ -272,32 +221,6 @@
   }
 
   void
-  Canvas::canvasAutoAxes (const graphics_handle& handle)
-  {
-    gh_manager::auto_lock lock;
-
-    graphics_object go = gh_manager::get_object (handle);
-
-    if (go.valid_object ())
-      {
-        figure::properties& fp = Utils::properties<figure> (go);
-
-        graphics_handle ah = fp.get_currentaxes ();
-
-        graphics_object ax = gh_manager::get_object (ah);
-
-        if (ax.valid_object ())
-          {
-            axes::properties& ap = Utils::properties<axes> (ax);
-
-            autoscale_axes (ap);
-
-            redraw (true);
-          }
-      }
-  }
-
-  void
   Canvas::canvasPaintEvent (void)
   {
     if (! m_redrawBlocked)
diff --git a/libgui/graphics/Canvas.h b/libgui/graphics/Canvas.h
--- a/libgui/graphics/Canvas.h
+++ b/libgui/graphics/Canvas.h
@@ -70,10 +70,6 @@
     static Canvas * create (const std::string& name, QWidget *parent,
                             const graphics_handle& handle);
 
-    virtual void toggleAxes (const graphics_handle& handle) = 0;
-    virtual void toggleGrid (const graphics_handle& handle) = 0;
-    virtual void autoAxes (const graphics_handle& handle) = 0;
-
     virtual uint8NDArray getPixels (void) { return do_getPixels (m_handle); };
 
   protected:
diff --git a/libgui/graphics/Figure.cc b/libgui/graphics/Figure.cc
--- a/libgui/graphics/Figure.cc
+++ b/libgui/graphics/Figure.cc
@@ -26,7 +26,6 @@
 
 #include <QAction>
 #include <QActionEvent>
-#include <QActionGroup>
 #include <QApplication>
 #include <QClipboard>
 #include <QEvent>
@@ -50,7 +49,6 @@
 #include "Container.h"
 #include "Figure.h"
 #include "FigureWindow.h"
-#include "MouseModeActionGroup.h"
 #include "QtHandlesUtils.h"
 
 #include "file-ops.h"
@@ -92,7 +90,7 @@
   Figure::Figure (const graphics_object& go, FigureWindow *win)
     : Object (go, win), m_blockUpdates (false), m_figureToolBar (nullptr),
       m_menuBar (nullptr), m_innerRect (), m_outerRect (),
-      m_mouseModeGroup (nullptr), m_previousHeight (0), m_resizable (true)
+      m_previousHeight (0), m_resizable (true)
   {
     m_container = new Container (win);
     win->setCentralWidget (m_container);
@@ -104,30 +102,23 @@
     connect (win, SIGNAL (figureWindowShown ()),
              this, SLOT (figureWindowShown ()));
 
+    // Menubar
+    m_menuBar = new MenuBar (win);
+    win->setMenuBar (m_menuBar);
+    m_menuBar->addReceiver (this);
+
     // Status bar
     m_statusBar = win->statusBar ();
     int boffset = 0;
 
-    // Toolbar and menubar
-    createFigureToolBarAndMenuBar ();
-    int toffset = 0;
-
     if (fp.toolbar_is ("figure")
         || (fp.toolbar_is ("auto") && fp.menubar_is ("figure")))
-      {
-        toffset += m_figureToolBar->sizeHint ().height ();
-        boffset += m_statusBar->sizeHint ().height ();
-      }
-    else
-      {
-        m_figureToolBar->hide ();
-        m_statusBar->hide ();
-      }
+      boffset += m_statusBar->sizeHint ().height ();
 
     m_innerRect = boundingBoxToRect (fp.get_boundingbox (true));
     m_outerRect = boundingBoxToRect (fp.get_boundingbox (false));
 
-    set_geometry (m_innerRect.adjusted (0, -toffset, 0, boffset));
+    set_geometry (m_innerRect.adjusted (0, 0, 0, boffset));
 
     // Enable mouse tracking unconditionally
     enableMouseTracking ();
@@ -162,55 +153,6 @@
   Figure::~Figure (void)
   { }
 
-  static std::string
-  mouse_mode_to_string (MouseMode mode)
-  {
-    switch (mode)
-      {
-      case NoMode:
-        return "none";
-
-      case RotateMode:
-        return "rotate";
-
-      case ZoomInMode:
-        return "zoom in";
-
-      case ZoomOutMode:
-        return "zoom out";
-
-      case PanMode:
-        return "pan";
-
-      case TextMode:
-        return "text";
-
-      default:
-        break;
-      }
-
-    return "none";
-  }
-
-  static MouseMode
-  mouse_mode_from_string (const std::string& mode)
-  {
-    if (mode == "none")
-      return NoMode;
-    else if (mode == "rotate")
-      return RotateMode;
-    else if (mode == "zoom in")
-      return ZoomInMode;
-    else if (mode == "zoom out")
-      return ZoomOutMode;
-    else if (mode == "pan")
-      return PanMode;
-    else if (mode == "text")
-      return TextMode;
-    else
-      return NoMode;
-  }
-
   QString
   Figure::fileName (void)
   {
@@ -251,49 +193,18 @@
         mode += ' ' + direction;
       }
 
-    return mouse_mode_from_string (mode);
-  }
-
-  void
-  Figure::createFigureToolBarAndMenuBar (void)
-  {
-    QMainWindow *win = qWidget<QMainWindow> ();
-
-    m_figureToolBar = win->addToolBar (tr ("Figure ToolBar"));
-    m_figureToolBar->setMovable (false);
-    m_figureToolBar->setFloatable (false);
-
-    m_mouseModeGroup = new MouseModeActionGroup (win);
-    connect (m_mouseModeGroup, SIGNAL (modeChanged (MouseMode)),
-             SLOT (setMouseMode (MouseMode)));
-    m_figureToolBar->addActions (m_mouseModeGroup->actions ());
-
-    QAction *toggle_axes = m_figureToolBar->addAction (tr ("Axes"));
-    connect (toggle_axes, SIGNAL (triggered (void)),
-             this, SLOT (toggleAxes (void)));
+    if (mode == "rotate")
+      return RotateMode;
+    else if (mode == "zoom in")
+      return ZoomInMode;
+    else if (mode == "zoom out")
+      return ZoomOutMode;
+    else if (mode == "pan")
+      return PanMode;
+    else if (mode == "text")
+      return TextMode;
 
-    QAction *toggle_grid = m_figureToolBar->addAction (tr ("Grid"));
-    connect (toggle_grid, SIGNAL (triggered (void)),
-             this, SLOT (toggleGrid (void)));
-
-    QAction *auto_axes = m_figureToolBar->addAction (tr ("Autoscale"));
-    connect (auto_axes, SIGNAL (triggered (void)),
-             this, SLOT (autoAxes (void)));
-
-    m_menuBar = new MenuBar (win);
-    win->setMenuBar (m_menuBar);
-    m_menuBar->addReceiver (this);
-  }
-
-  void
-  Figure::updateFigureToolBarAndMenuBar (void)
-  {
-    if (m_mouseModeGroup)
-      {
-        m_blockUpdates = true;
-        m_mouseModeGroup->setMode (mouseMode ());
-        m_blockUpdates = false;
-      }
+    return NoMode;
   }
 
   void
@@ -349,8 +260,6 @@
               obj->slotRedraw ();
           }
       }
-
-    updateFigureToolBarAndMenuBar ();
   }
 
   void
@@ -395,7 +304,6 @@
     if (canvas)
       canvas->blockRedraw (true);
 
-    m_menuBar->removeReceiver (this);
     m_container->removeReceiver (this);
     qWidget<FigureWindow> ()->removeReceiver (this);
   }
@@ -522,6 +430,7 @@
         break;
 
       case figure::properties::ID___MOUSE_MODE__:
+      case figure::properties::ID___ZOOM_MODE__:
         m_container->canvas (m_handle)->setCursor (mouseMode ());
         break;
 
@@ -535,7 +444,8 @@
   void
   Figure::showFigureToolBar (bool visible)
   {
-    if ((! m_figureToolBar->isHidden ()) != visible)
+    if (m_figureToolBar
+        && (! m_figureToolBar->isHidden ()) != visible)
       {
         int dy1 = m_figureToolBar->sizeHint ().height ();
         int dy2 = m_statusBar->sizeHint ().height ();
@@ -786,28 +696,13 @@
   }
 
   void
-  Figure::setMouseMode (MouseMode mode)
-  {
-    if (m_blockUpdates)
-      return;
-
-    gh_manager::auto_lock lock;
-
-    figure::properties& fp = properties<figure> ();
-
-    fp.set___mouse_mode__ (mouse_mode_to_string (mode));
-
-    Canvas *canvas = m_container->canvas (m_handle);
-
-    if (canvas)
-      canvas->setCursor (mode);
-  }
-
-  void
-  Figure::addCustomToolBar (QToolBar *bar, bool visible)
+  Figure::addCustomToolBar (QToolBar *bar, bool visible, bool isdefault)
   {
     QMainWindow *win = qWidget<QMainWindow> ();
 
+    if (isdefault)
+      m_figureToolBar = bar;
+
     if (! visible)
       win->addToolBar (bar);
     else
@@ -860,33 +755,6 @@
   }
 
   void
-  Figure::toggleAxes (void)
-  {
-    Canvas *canvas = m_container->canvas (m_handle);
-
-    if (canvas)
-      canvas->toggleAxes (m_handle);
-  }
-
-  void
-  Figure::toggleGrid (void)
-  {
-    Canvas *canvas = m_container->canvas (m_handle);
-
-    if (canvas)
-      canvas->toggleGrid (m_handle);
-  }
-
-  void
-  Figure::autoAxes (void)
-  {
-    Canvas *canvas = m_container->canvas (m_handle);
-
-    if (canvas)
-      canvas->autoAxes (m_handle);
-  }
-
-  void
   Figure::figureWindowShown ()
   {
 #if defined (HAVE_QSCREEN_DEVICEPIXELRATIO)
diff --git a/libgui/graphics/Figure.h b/libgui/graphics/Figure.h
--- a/libgui/graphics/Figure.h
+++ b/libgui/graphics/Figure.h
@@ -39,15 +39,13 @@
 
   enum MouseMode
   {
-    // NOTE: These values must match the order of the buttons in the
-    // MouseModeActionGroup object.
-
-    NoMode      = 0,
-    RotateMode  = 1,
-    ZoomInMode  = 2,
-    ZoomOutMode = 3,
-    PanMode     = 4,
-    TextMode    = 5
+    NoMode,
+    RotateMode,
+    ZoomInMode,
+    ZoomOutMode,
+    PanMode,
+    SelectMode,
+    TextMode
   };
 
   class Container;
@@ -55,8 +53,6 @@
   class MenuBar;
   class ToolBar;
 
-  class MouseModeActionGroup;
-
   class Figure :
   public Object,
   public MenuContainer,
@@ -101,22 +97,16 @@
     void beingDeleted (void);
 
   private:
-    void createFigureToolBarAndMenuBar (void);
     void showFigureToolBar (bool visible);
-    void addCustomToolBar (QToolBar *bar, bool visible);
+    void addCustomToolBar (QToolBar *bar, bool visible, bool isdefault);
     void showCustomToolBar (QToolBar *bar, bool visible);
-    void updateFigureToolBarAndMenuBar (void);
     void set_geometry (QRect r);
 
     void enableMouseTracking (void);
 
   private slots:
-    void setMouseMode (MouseMode mode);
     void updateFigureHeight (int delta_h);
     void updateContainer (void);
-    void toggleAxes (void);
-    void toggleGrid (void);
-    void autoAxes (void);
     void figureWindowShown ();
     void screenChanged (QScreen*);
 
@@ -134,7 +124,6 @@
     QStatusBar *m_statusBar;
     QRect m_innerRect;
     QRect m_outerRect;
-    MouseModeActionGroup *m_mouseModeGroup;
     int m_previousHeight;
     bool m_resizable;
   };
diff --git a/libgui/graphics/GLCanvas.cc b/libgui/graphics/GLCanvas.cc
--- a/libgui/graphics/GLCanvas.cc
+++ b/libgui/graphics/GLCanvas.cc
@@ -159,24 +159,6 @@
       }
   }
 
-  void
-  GLCanvas::toggleAxes (const graphics_handle& gh)
-  {
-    canvasToggleAxes (gh);
-  }
-
-  void
-  GLCanvas::toggleGrid (const graphics_handle& gh)
-  {
-    canvasToggleGrid (gh);
-  }
-
-  void
-  GLCanvas::autoAxes (const graphics_handle& gh)
-  {
-    canvasAutoAxes (gh);
-  }
-
   graphics_object
   GLCanvas::selectFromAxes (const graphics_object& ax, const QPoint& pt)
   {
diff --git a/libgui/graphics/GLCanvas.h b/libgui/graphics/GLCanvas.h
--- a/libgui/graphics/GLCanvas.h
+++ b/libgui/graphics/GLCanvas.h
@@ -60,9 +60,6 @@
     uint8NDArray  do_getPixels (const graphics_handle& handle);
     void do_print (const QString& file_cmd, const QString& term,
                    const graphics_handle& handle);
-    void toggleAxes (const graphics_handle& handle);
-    void toggleGrid (const graphics_handle& handle);
-    void autoAxes (const graphics_handle& handle);
     void drawZoomBox (const QPoint& p1, const QPoint& p2);
     void resize (int /* x */, int /* y */,
                  int /* width */, int /* height */) { }
diff --git a/libgui/graphics/ToolBar.cc b/libgui/graphics/ToolBar.cc
--- a/libgui/graphics/ToolBar.cc
+++ b/libgui/graphics/ToolBar.cc
@@ -94,7 +94,8 @@
       dynamic_cast<Figure *> (Object::fromQObject (bar->parentWidget ()));
 
     if (m_figure)
-      m_figure->addCustomToolBar (bar, tp.is_visible ());
+      m_figure->addCustomToolBar (bar, tp.is_visible (),
+                                  tp.get_tag () == "__default_toolbar__");
 
     bar->installEventFilter (this);
   }
diff --git a/libgui/graphics/ToolBarButton.cc b/libgui/graphics/ToolBarButton.cc
--- a/libgui/graphics/ToolBarButton.cc
+++ b/libgui/graphics/ToolBarButton.cc
@@ -29,6 +29,7 @@
 
 #include "ToolBarButton.h"
 #include "QtHandlesUtils.h"
+#include "resource-manager.h"
 
 namespace QtHandles
 {
@@ -41,8 +42,22 @@
 
     action->setToolTip (Utils::fromStdString (tp.get_tooltipstring ()));
     action->setVisible (tp.is_visible ());
-    QImage img = Utils::makeImageFromCData (tp.get_cdata (), 16, 16);
-    action->setIcon (QIcon (QPixmap::fromImage (img)));
+
+    // Get the icon data from cdata or as a named icon
+    QImage img = Utils::makeImageFromCData (tp.get_cdata (), 32, 32);
+    
+    if (img.width () == 0)
+      {
+        QIcon ico;
+        std::string name = tp.get___named_icon__ ();
+        if (! name.empty ())
+          ico = octave::resource_manager::icon (QString::fromStdString (name));
+
+        action->setIcon (ico);
+      }
+    else   
+      action->setIcon (QIcon (QPixmap::fromImage (img)));
+    
     if (tp.is_separator ())
       {
         m_separator = new QAction (action);
@@ -83,9 +98,20 @@
 
       case T::properties::ID_CDATA:
         {
-          QImage img = Utils::makeImageFromCData (tp.get_cdata (), 16, 16);
-
-          action->setIcon (QIcon (QPixmap::fromImage (img)));
+          // Get the icon data from cdata or as a named icon
+          QImage img = Utils::makeImageFromCData (tp.get_cdata (), 32, 32);
+          
+          if (img.width () == 0)
+            {
+              QIcon ico;
+              std::string name = tp.get___named_icon__ ();
+              if (! name.empty ())
+                ico = octave::resource_manager::icon (QString::fromStdString (name));
+              action->setIcon (ico);
+          
+            }
+          else
+            action->setIcon (QIcon (QPixmap::fromImage (img)));
         }
         break;
 
diff --git a/libgui/graphics/module.mk b/libgui/graphics/module.mk
--- a/libgui/graphics/module.mk
+++ b/libgui/graphics/module.mk
@@ -13,7 +13,6 @@
   %reldir%/moc-FigureWindow.cc \
   %reldir%/moc-ListBoxControl.cc \
   %reldir%/moc-Menu.cc \
-  %reldir%/moc-MouseModeActionGroup.cc \
   %reldir%/moc-Object.cc \
   %reldir%/moc-ObjectFactory.cc \
   %reldir%/moc-ObjectProxy.cc \
@@ -40,12 +39,6 @@
 
 $(__init_qt___UI_H): | %reldir%/$(octave_dirstamp)
 
-BUILT_SOURCES += $(__init_qt___UI_H)
-
-__init_qt___RC = %reldir%/qrc-qthandles.cc
-
-$(__init_qt___RC): | %reldir%/$(octave_dirstamp)
-
 noinst_HEADERS += \
   %reldir%/__init_qt__.h \
   %reldir%/annotation-dialog.h \
@@ -67,7 +60,6 @@
   %reldir%/Logger.h \
   %reldir%/Menu.h \
   %reldir%/MenuContainer.h \
-  %reldir%/MouseModeActionGroup.h \
   %reldir%/Object.h \
   %reldir%/ObjectFactory.h \
   %reldir%/ObjectProxy.h \
@@ -108,7 +100,6 @@
   %reldir%/ListBoxControl.cc \
   %reldir%/Logger.cc \
   %reldir%/Menu.cc \
-  %reldir%/MouseModeActionGroup.cc \
   %reldir%/Object.cc \
   %reldir%/ObjectFactory.cc \
   %reldir%/ObjectProxy.cc \
@@ -130,7 +121,7 @@
 TEMPLATE_SRC = \
   %reldir%/ToolBarButton.cc
 
-nodist_%canon_reldir%___init_qt___la_SOURCES = $(__init_qt___MOC) $(__init_qt___RC)
+nodist_%canon_reldir%___init_qt___la_SOURCES = $(__init_qt___MOC)
 
 %canon_reldir%___init_qt___la_CPPFLAGS = \
   $(AM_CPPFLAGS) \
@@ -193,20 +184,12 @@
   $(GRAPHICS_PKG_ADD_FILE)
 
 libgui_EXTRA_DIST += \
-  %reldir%/qthandles.qrc \
-  %reldir%/images/README \
-  %reldir%/images/pan.png \
-  %reldir%/images/rotate.png \
-  %reldir%/images/select.png \
-  %reldir%/images/zoom-in.png \
-  %reldir%/images/zoom-out.png \
   $(__init_qt___UI)
 
 libgui_CLEANFILES += \
   $(GRAPHICS_OCT_FILES) \
   $(GRAPHICS_PKG_ADD_FILE) \
   $(__init_qt___MOC) \
-  $(__init_qt___RC) \
   $(__init_qt___UI_H)
 
 endif
diff --git a/libgui/src/icons/icons_license b/libgui/src/icons/icons_license
--- a/libgui/src/icons/icons_license
+++ b/libgui/src/icons/icons_license
@@ -33,6 +33,11 @@
 edit-paste.svg
 edit-redo.svg
 edit-undo.svg
+figure-rotate.svg           (original file view-refresh.svg)
+figure-text.svg             (original file font-x-generic.svg)
+figure-zoom-in.svg          (original file view-zoom-in.svg)
+figure-zoom-original.svg    (original file view-zoom-original.svg)
+figure-zoom-out.svg         (original file view-zoom-out.svg)
 folder.svg
 folder-new.svg
 go-down.svg
@@ -45,12 +50,15 @@
 preferences-system.svg
 user-home.svg
 view-refresh.svg
+view-refresh.svg
 
 ===========================================
 Icons created by the Octave developers
 with elements from the Tango theme
 ===========================================
 
+figure-axes.svg
+figure-grid.svg
 logo.png
 widget-close.svg
 widget-dock.svg
@@ -59,6 +67,7 @@
 Icons with elements from the Tango theme
 ===========================================
 
+figure-pan.svg
 graphic_logo_DocumentationDockWidget.svg
 graphic_logo_FileEditor.svg
 graphic_logo_FilesDockWidget.svg
diff --git a/libgui/src/module.mk b/libgui/src/module.mk
--- a/libgui/src/module.mk
+++ b/libgui/src/module.mk
@@ -24,6 +24,14 @@
   %reldir%/icons/edit-find-replace.png \
   %reldir%/icons/edit-paste.png \
   %reldir%/icons/edit-redo.png \
+  %reldir%/icons/figure-axes.png \
+  %reldir%/icons/figure-grid.png \
+  %reldir%/icons/figure-pan.png \
+  %reldir%/icons/figure-rotate.png \
+  %reldir%/icons/figure-text.png \
+  %reldir%/icons/figure-zoom-in.png \
+  %reldir%/icons/figure-zoom-original.png \
+  %reldir%/icons/figure-zoom-out.png \
   %reldir%/icons/edit-undo.png \
   %reldir%/icons/folder.png \
   %reldir%/icons/folder-new.png \
diff --git a/libgui/src/resource.qrc b/libgui/src/resource.qrc
--- a/libgui/src/resource.qrc
+++ b/libgui/src/resource.qrc
@@ -26,6 +26,14 @@
         <file>icons/edit-paste.png</file>
         <file>icons/edit-redo.png</file>
         <file>icons/edit-undo.png</file>
+        <file>icons/figure-axes.png</file>
+        <file>icons/figure-grid.png</file>
+        <file>icons/figure-pan.png</file>
+        <file>icons/figure-rotate.png</file>
+        <file>icons/figure-text.png</file>
+        <file>icons/figure-zoom-in.png</file>
+        <file>icons/figure-zoom-original.png</file>
+        <file>icons/figure-zoom-out.png</file>
         <file>icons/folder.png</file>
         <file>icons/folder-new.png</file>
         <file>icons/go-down.png</file>
diff --git a/libinterp/corefcn/graphics.in.h b/libinterp/corefcn/graphics.in.h
--- a/libinterp/corefcn/graphics.in.h
+++ b/libinterp/corefcn/graphics.in.h
@@ -5978,6 +5978,7 @@
       string_property tooltipstring , ""
 
       // Octave-specific properties
+      string_property __named_icon__ , ""
       any_property __object__ h , Matrix ()
     END_PROPERTIES
 
@@ -6041,6 +6042,7 @@
       string_property tooltipstring , ""
 
       // Octave-specific properties
+      string_property __named_icon__ , ""
       any_property __object__ h , Matrix ()
     END_PROPERTIES
 
diff --git a/scripts/plot/appearance/annotation.m b/scripts/plot/appearance/annotation.m
--- a/scripts/plot/appearance/annotation.m
+++ b/scripts/plot/appearance/annotation.m
@@ -850,7 +850,7 @@
       val = label = vals{ii};
     else
       val = vals(ii);
-      label = num2str (val);
+      label = disp (val);
     endif
 
     fcn = @() set (hpar, pname, val);
@@ -867,7 +867,7 @@
   vals = get (hmenus, "label");
   current = get (h, prop);
   if (is_numeric)
-    current = num2str (current);
+    current = disp (current);
   endif
 
   idx = strcmp (vals, current);
diff --git a/scripts/plot/util/clf.m b/scripts/plot/util/clf.m
--- a/scripts/plot/util/clf.m
+++ b/scripts/plot/util/clf.m
@@ -71,15 +71,17 @@
 
   if (do_reset)
     ## Delete all the children, including the ones with hidden handles,
-    ## except default menus.
+    ## except default menus and toolbar.
     kids = allchild (hfig);
     ismenu = cellfun (@(s) strncmp (s, "__default_menu_", 15), ...
                       get (kids, "tag"));
-    delete (kids(! ismenu));
+    istoolbar = cellfun (@(s) strncmp (s, "__default_toolbar_menu_", 18), ...
+                         get (kids, "tag"));
+    delete (kids(! ismenu & ! istoolbar));
     reset (hfig);
 
     ## Recover figure listeners which have been deleted
-    __add_default_menu__ (hfig, kids(ismenu));
+    __add_default_menu__ (hfig, kids(ismenu), kids(istoolbar));
 
     __set_default_mouse_modes__ (hfig);
   else
